package com.frikinjay.letmedespawn.command;

import com.frikinjay.letmedespawn.LetMeDespawn;
import com.mojang.brigadier.CommandDispatcher;
import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.suggestion.Suggestions;
import com.mojang.brigadier.suggestion.SuggestionsBuilder;
import java.util.Objects;
import java.util.concurrent.CompletableFuture;
import java.util.stream.Stream;
import net.minecraft.class_124;
import net.minecraft.class_1311;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_2561;
import net.minecraft.class_7923;

public class LetMeDespawnCommands {
   public static void register(CommandDispatcher<class_2168> dispatcher) {
      dispatcher.register((LiteralArgumentBuilder)((LiteralArgumentBuilder)((LiteralArgumentBuilder)((LiteralArgumentBuilder)((LiteralArgumentBuilder)class_2170.method_9247("letmedespawn").requires((source) -> {
         return source.method_9259(2);
      })).then(class_2170.method_9247("add").then(class_2170.method_9244("mobName", StringArgumentType.greedyString()).suggests(LetMeDespawnCommands::suggestMobNames).executes(LetMeDespawnCommands::addMob)))).then(class_2170.method_9247("remove").then(class_2170.method_9244("mobName", StringArgumentType.greedyString()).suggests(LetMeDespawnCommands::suggestConfiguredMobNames).executes(LetMeDespawnCommands::removeMob)))).then(class_2170.method_9247("addPersistenceEnabler").then(class_2170.method_9244("itemName", StringArgumentType.greedyString()).suggests(LetMeDespawnCommands::suggestItems).executes(LetMeDespawnCommands::addItem)))).then(class_2170.method_9247("removePersistenceEnabler").then(class_2170.method_9244("itemName", StringArgumentType.greedyString()).suggests(LetMeDespawnCommands::suggestConfiguredItems).executes(LetMeDespawnCommands::removeItem))));
   }

   private static CompletableFuture<Suggestions> suggestMobNames(CommandContext<class_2168> context, SuggestionsBuilder builder) {
      class_7923.field_41177.forEach((entityType) -> {
         if (entityType.method_5891().equals(class_1311.field_6302)) {
            builder.suggest(class_7923.field_41177.method_10221(entityType).toString());
         }

      });
      return builder.buildFuture();
   }

   private static CompletableFuture<Suggestions> suggestConfiguredMobNames(CommandContext<class_2168> context, SuggestionsBuilder builder) {
      Stream var10000 = LetMeDespawn.config.getMobNames().stream().filter((mobName) -> {
         return mobName.startsWith(builder.getRemaining());
      });
      Objects.requireNonNull(builder);
      var10000.forEach(builder::suggest);
      return builder.buildFuture();
   }

   private static int addMob(CommandContext<class_2168> context) {
      String mobName = StringArgumentType.getString(context, "mobName");
      if (LetMeDespawn.config.getMobNames().contains(mobName)) {
         ((class_2168)context.getSource()).method_9226(() -> {
            return class_2561.method_43470("Mob '" + mobName + "' is already in the configuration.").method_27692(class_124.field_1061);
         }, false);
      } else {
         LetMeDespawn.config.addMobName(mobName);
         ((class_2168)context.getSource()).method_9226(() -> {
            return class_2561.method_43470("Added '" + mobName + "' to LetMeDespawn configuration.").method_27692(class_124.field_1075);
         }, true);
      }

      return 1;
   }

   private static int removeMob(CommandContext<class_2168> context) {
      String mobName = StringArgumentType.getString(context, "mobName");
      if (LetMeDespawn.config.getMobNames().contains(mobName)) {
         LetMeDespawn.config.removeMobName(mobName);
         ((class_2168)context.getSource()).method_9226(() -> {
            return class_2561.method_43470("Removed '" + mobName + "' from LetMeDespawn configuration.").method_27692(class_124.field_1065);
         }, true);
      } else {
         ((class_2168)context.getSource()).method_9226(() -> {
            return class_2561.method_43470("Mob '" + mobName + "' is not in the configuration.").method_27692(class_124.field_1061);
         }, false);
      }

      return 1;
   }

   private static CompletableFuture<Suggestions> suggestItems(CommandContext<class_2168> context, SuggestionsBuilder builder) {
      class_7923.field_41178.forEach((item) -> {
         builder.suggest(class_7923.field_41178.method_10221(item).toString());
      });
      return builder.buildFuture();
   }

   private static CompletableFuture<Suggestions> suggestConfiguredItems(CommandContext<class_2168> context, SuggestionsBuilder builder) {
      Stream var10000 = LetMeDespawn.config.getPersistenceEnablers().stream().filter((itemName) -> {
         return itemName.startsWith(builder.getRemaining());
      });
      Objects.requireNonNull(builder);
      var10000.forEach(builder::suggest);
      return builder.buildFuture();
   }

   private static int addItem(CommandContext<class_2168> context) {
      String itemName = StringArgumentType.getString(context, "itemName");
      if (LetMeDespawn.config.getPersistenceEnablers().contains(itemName)) {
         ((class_2168)context.getSource()).method_9226(() -> {
            return class_2561.method_43470("Item '" + itemName + "' is already a persistence enabler.").method_27692(class_124.field_1061);
         }, false);
      } else {
         LetMeDespawn.config.addPersistenceEnabler(itemName);
         ((class_2168)context.getSource()).method_9226(() -> {
            return class_2561.method_43470("Added '" + itemName + "' to persistence enablers.").method_27692(class_124.field_1075);
         }, true);
      }

      return 1;
   }

   private static int removeItem(CommandContext<class_2168> context) {
      String itemName = StringArgumentType.getString(context, "itemName");
      if (LetMeDespawn.config.getPersistenceEnablers().contains(itemName)) {
         LetMeDespawn.config.removePersistenceEnabler(itemName);
         ((class_2168)context.getSource()).method_9226(() -> {
            return class_2561.method_43470("Removed '" + itemName + "' from persistence enablers.").method_27692(class_124.field_1065);
         }, true);
      } else {
         ((class_2168)context.getSource()).method_9226(() -> {
            return class_2561.method_43470("Item '" + itemName + "' is not a persistence enabler.").method_27692(class_124.field_1061);
         }, false);
      }

      return 1;
   }
}
